/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-browser.h"

// Create a new browser object. This is the side panel along
// the right of the application.
Browser* openldev_browser_new ()
{
  Browser *browser = new Browser ();

  browser->files = openldev_browser_project_new ();
  browser->notebook = gtk_notebook_new ();
  openldev_browser_add_tab (browser, browser->files->scrolled_window, 
                            gtk_label_new("Files"));
  
  return browser;
}

GtkWidget* openldev_browser_get_notebook (Browser *browser)
{ return browser->notebook;
}

// Add a new tab to the browser
void openldev_browser_add_tab (Browser *browser, 
                               GtkWidget *child, 
                               GtkWidget *tab_label)
{ 
  gtk_notebook_append_page (GTK_NOTEBOOK (browser->notebook), 
                            child, tab_label);
}

BrowserProject* openldev_browser_get_browser_files (Browser *browser)
{ return browser->files;
}
