/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MENU_WIDGET_H
#define MENU_WIDGET_H

#include <gtk/gtk.h>

typedef struct _MenuHandle  MenuHandle;

struct _MenuHandle
{
  GtkWidget *menubar;
  GtkWidget *popup_filebrowser;
  GtkWidget *popup_buildoutput;
  GtkWidget *popup_searchoutput;
  GtkWidget *toolbar;
  GtkActionGroup *group;
  GtkUIManager *uimanager;
};

MenuHandle* openldev_menu_handle_new ();

GtkWidget* openldev_menu_handle_get_menubar (MenuHandle*);
GtkWidget* openldev_menu_handle_get_popup   (MenuHandle*);
GtkWidget* openldev_menu_handle_get_toolbar (MenuHandle*);

GtkActionGroup* openldev_menu_handle_get_action_group (MenuHandle*);
GtkUIManager*   openldev_menu_handle_get_uimanager    (MenuHandle*);

#endif
