/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-output-terminal.h"

// Create a new terminal output tab
OutputTerminal* openldev_output_terminal_new ()
{
  OutputTerminal *obj = new OutputTerminal ();
  
  int value;
  
  obj->terminal = vte_terminal_new ();
  value = vte_terminal_fork_command (VTE_TERMINAL(obj->terminal), 
          "/bin/bash", NULL, NULL, NULL, FALSE, FALSE, FALSE);
  vte_terminal_set_font_from_string (VTE_TERMINAL(obj->terminal), "Monospace 10");
  GTK_WIDGET_SET_FLAGS (VTE_TERMINAL(obj->terminal), GTK_CAN_FOCUS);
  vte_terminal_set_scroll_on_output (VTE_TERMINAL(obj->terminal), FALSE);
  vte_terminal_set_scroll_on_keystroke (VTE_TERMINAL(obj->terminal), TRUE);
  vte_terminal_set_mouse_autohide (VTE_TERMINAL(obj->terminal), TRUE);
  
  obj->scrollbar = gtk_vscrollbar_new (vte_terminal_get_adjustment(VTE_TERMINAL(obj->terminal)));
  obj->hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX(obj->hbox), obj->terminal, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX(obj->hbox), obj->scrollbar, FALSE, FALSE, 0);  
  
  gtk_widget_show (obj->terminal);
  gtk_widget_show (obj->scrollbar);
  gtk_widget_show (obj->hbox);
  
  return obj;
}

// Run a commend in the terminal
void openldev_output_terminal_run_command (OutputTerminal *obj,
                                           const char *command)
{ vte_terminal_feed_child (VTE_TERMINAL(obj->terminal), command, strlen(command));
}

// Let the terminal grab focus from the application
void openldev_output_terminal_grab_focus (OutputTerminal *obj)
{ gtk_widget_grab_focus (obj->terminal);
}

GtkWidget* openldev_output_terminal_get_terminal (OutputTerminal *obj)
{ return obj->terminal;
}

GtkWidget* openldev_output_terminal_get_hbox (OutputTerminal *obj)
{ return obj->hbox;
}
