/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-status-bar.h"

// Create a new gnome application bar
StatusBar* openldev_status_bar_new ()
{
  StatusBar *statusbar = new StatusBar();
  statusbar->appbar = gnome_appbar_new (TRUE, TRUE, GNOME_PREFERENCES_NEVER);
  statusbar->locked = FALSE;
  return statusbar;
}

// Set the status bar to have a new message
void openldev_status_bar_set_message (StatusBar *statusbar, 
                                      gchar *message)
{
  if (!statusbar->locked)
  {
    gnome_appbar_pop (GNOME_APPBAR (statusbar->appbar));
    gnome_appbar_push (GNOME_APPBAR (statusbar->appbar), message);
    gnome_appbar_refresh (GNOME_APPBAR (statusbar->appbar));
  }
}

void openldev_status_bar_lock_message (StatusBar *statusbar,
                                       gchar *message)
{
  if (!statusbar->locked)
  {
    gnome_appbar_push (GNOME_APPBAR (statusbar->appbar), message);
    gnome_appbar_refresh (GNOME_APPBAR (statusbar->appbar));
    statusbar->locked = TRUE;
  }
}

void openldev_status_bar_unlock_message (StatusBar *statusbar)
{
  gnome_appbar_pop (GNOME_APPBAR (statusbar->appbar));
  statusbar->locked = FALSE;
}
