/***************************************************************************
 *   Copyright (C) 2006 by Andrew Krause                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "makefile-editor-add.h"

void makefile_editor_add (GtkButton *add, 
                          gpointer data)
{
  MakefileEditor *editor = (MakefileEditor*) data;
  
  // Make sure that there is a Makefile to add something to
  if (gtk_tree_model_iter_n_children (gtk_tree_view_get_model 
      (GTK_TREE_VIEW (editor->content)), NULL) > 0)
  {
    Makefile *mf = openldev_makefile_parser_new (g_strconcat (editor->project->location.c_str(), 
                                                 editor->current_path.c_str(), 
                                                 "Makefile.am", NULL));
    GladeXML *xml = glade_xml_new (g_strconcat (INSTALL_PREFIX, "/share/openldev/glade/", 
                                   "mfeditor-add.glade", NULL), NULL, NULL);
    GtkWidget *dialog = glade_xml_get_widget (xml, "dialog");
    GtkWidget *combobox = glade_xml_get_widget (xml, "type");
    gtk_combo_box_set_active (GTK_COMBO_BOX (combobox), 0);
    
    if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
    {
      string type = gtk_combo_box_get_active_text (GTK_COMBO_BOX (combobox));
      
      if (type == "Variable")
      {
        MakefileAttr *obj = new MakefileAttr;
        obj->attr.push_back ("Content");
        mf->types.push_back (MAKEFILE_ARRAY);
        mf->attributes.push_back (obj);
        mf->names.push_back ("New_Variable");
      }
      else if (type == "Script")
      {
        MakefileAttr *obj = new MakefileAttr;
        obj->attr.push_back ("Script Content");
        mf->types.push_back (MAKEFILE_SCRIPT);
        mf->attributes.push_back (obj);
        mf->names.push_back ("target: dependencies");
      }
      else if (type == "Target")
      {
        MakefileAttr *obj = new MakefileAttr;
        obj->attr.push_back ("New_Target");
        mf->types.push_back (MAKEFILE_ARRAY);
        mf->attributes.push_back (obj);
        mf->names.push_back ("newprefix_PROGRAMS");
      }
    }
    
    openldev_makefile_parser_write (mf);
    makefile_editor_populate (editor);
    gtk_widget_destroy (dialog);    
  }
}
